Package org.apache.commons.io.filefilter

# Class CanExecuteFileFilter

java.lang.Object
org.apache.commons.io.filefilter.AbstractFileFilter
org.apache.commons.io.filefilter.CanExecuteFileFilter

All Implemented Interfaces:
  `FileFilter`, `FilenameFilter`, `Serializable`, `FileVisitor<Path>`, `PathMatcher`, `PathFilter`, `PathVisitor`, `IOFileFilter`

public class CanExecuteFileFilter extends AbstractFileFilter implements Serializable
This filter accepts `File`s that can be executed.

Example, showing how to print out a list of the current directory's executable files:

## Using Classic IO

     File dir = FileUtils.current();
     String[] files = dir.list(CanExecuteFileFilter.CAN_EXECUTE);
     for (String file : files) {
         System.out.println(file);
     }

Example, showing how to print out a list of the current directory's non-executable files:

     File dir = FileUtils.current();
     String[] files = dir.list(CanExecuteFileFilter.CANNOT_EXECUTE);
     for (int i = 0; i < files.length; i++) {
         System.out.println(files[i]);
     }

## Deprecating Serialization

Serialization is deprecated and will be removed in 3.0.

Since:
  2.7
See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final IOFileFilter`
  `CAN_EXECUTE`
  Singleton instance of executable filter
  `static final IOFileFilter`
  `CANNOT_EXECUTE`
  Singleton instance of not executable filter

  ### Fields inherited from interface org.apache.commons.io.filefilter.IOFileFilter

  `EMPTY_STRING_ARRAY`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CanExecuteFileFilter()`
  Restrictive constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `accept(File file)`
  Checks to see if the file can be executed.
  `FileVisitResult`
  `accept(Path file, BasicFileAttributes attributes)`
  Checks to see if the file can be executed.

  ### Methods inherited from class org.apache.commons.io.filefilter.AbstractFileFilter

  `accept, handle, postVisitDirectory, preVisitDirectory, toString, visitFile, visitFileFailed`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.commons.io.filefilter.IOFileFilter

  `and, matches, negate, or`

- ## Field Details

  - ### CAN_EXECUTE

    public static final IOFileFilter CAN_EXECUTE
    Singleton instance of executable filter

  - ### CANNOT_EXECUTE

    public static final IOFileFilter CANNOT_EXECUTE
    Singleton instance of not executable filter

- ## Constructor Details

  - ### CanExecuteFileFilter

    protected CanExecuteFileFilter()
    Restrictive constructor.

- ## Method Details

  - ### accept

    public boolean accept(File file)
    Checks to see if the file can be executed.
    Specified by:
      `accept` in interface `FileFilter`
    Specified by:
      `accept` in interface `IOFileFilter`
    Overrides:
      `accept` in class `AbstractFileFilter`
    Parameters:
      `file` - the File to check.
    Returns:
      `true` if the file can be executed, otherwise `false`.

  - ### accept

    public FileVisitResult accept(Path file, BasicFileAttributes attributes)
    Checks to see if the file can be executed.
    Specified by:
      `accept` in interface `IOFileFilter`
    Specified by:
      `accept` in interface `PathFilter`
    Parameters:
      `file` - the File to check.
      `attributes` - the path's basic attributes (may be null).
    Returns:
      `true` if the file can be executed, otherwise `false`.
    Since:
      2.9.0